/*****************************************
 * Large Assignment 1: L-Systems
 * Name:    Atah Omar
 * E-mail:  aomar1@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    9/14/23
 *
 * This program includes multiple rules for L-System designs
* To draw the Rose Bush, change rules variable name to rulesRoseBush
* To draw the Long Plant, change rules variable name to rulesLongPlant
* To draw the Sunflower, change rules variable name to rulesSunflower
***********************************************/


class Lsystem{
  String axiom = "F";
  // Rule set to create the rose bush design
  String [][] rulesRoseBush = {{"F","FF+[+F-F-F]-[-F+F+F]"},
                       {"+","+"},
                       {"-","-"},
                       {"[","["},
                       {"]","]"}};
  //Rule set to create the long plant design
  String [][] rulesLongPlant = {{"F","F[+F]F[-F]F"},
                       {"+","+"},
                       {"-","-"},
                       {"[","["},
                       {"]","]"}};
  //Rule set to create the sunflower desgin                     
  String [][] rulesSunflower = {{"F","FF[+F][-F]F"},
                       {"+","+"},
                       {"-","-"},
                       {"[","["},
                       {"]","]"}};
                      
                       
  String computeWord;
  int iterations;
  float size,angle,scaleFactor;
  Lsystem(float size,float angle,float scaleFactor){
    computeWord = axiom;
    iterations = 0;
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
  }
  
  void iteration(){
    char s;
    String newWord = "";
    size = size * scaleFactor;
    for(int i = 0;i<computeWord.length();i++){
       s = computeWord.charAt(i);
       //To change designs make sure to change the rules name
       for(int j = 0;j<rulesRoseBush.length;j++){
          if(s == rulesRoseBush[j][0].charAt(0)){
             newWord = newWord + rulesRoseBush[j][1];
             break;
          }
       }
    }
    iterations++;
    computeWord = newWord;
    println(iterations +": "+ computeWord);
  }
  
  /**
  This drawLsystem method is the draw system to the rose bush
  design and the long plant design, to use this method just uncomment it
  and comment the other one
  **/
  /*void drawLsystem(Turtle t){
     char s;
     for(int i = 0; i<computeWord.length();i++){
       s = computeWord.charAt(i);
       if(s == 'F'){
         t.forward(size);
         fill(0, 128, 0); // Green color
         noStroke();
         ellipse(t.getX(), t.getY(), 5, 8.5); // Adjust the size and shape of the leaf
         stroke(0);
         noFill();
         //drawRose(t);
       }
       else if(s == 'X'){
         fill(255,0,0);
         noStroke();
         ellipse(t.getX(),t.getY(),2,2);
         stroke(0);
         noFill();
       }
       else if(s == '+'){
         t.right(angle);
       }
       else if(s == '-')
         t.left(angle);
       else if(s == '[')
         t.push();
       else if(s == ']')
         t.pop();
     }
  }*/
  
  /**
  drawLsystem to draw the sunflower design
  **/
  void drawLsystem(Turtle t){
     char s;
     for(int i = 0; i < computeWord.length(); i++){
       s = computeWord.charAt(i);
       if(s == 'F'){
         t.forward(size);
         fill(0, 128, 0); // Green color
         noStroke();
         ellipse(t.getX(), t.getY(), 5, 8.5); // Adjust the size and shape of the leaf
         stroke(0);
         noFill();
         // Draw a sunflower at the end of each branch
         drawSunflower(t.getX(), t.getY());
       }
       else if(s == 'X'){
         fill(255, 0, 0);
         noStroke();
         ellipse(t.getX(), t.getY(), 2, 2);
         stroke(0);
         noFill();
       }
       else if(s == '+'){
         t.right(angle);
       }
       else if(s == '-')
         t.left(angle);
       else if(s == '[')
         t.push();
       else if(s == ']')
         t.pop();
     }
}



  /** 
  Method to create(attempt) the roses for the rose bush
  **/
  void drawRose(Turtle t) {
  fill(255, 0, 0); // Red color
  noStroke();
  float petalSize = 1.5; // Adjust the size of the petals
  float petalCount = 6; // Adjust the number of petals
  float angleIncrement = 360 / petalCount;
  float currentAngle = 0;
  
  for (int i = 0; i < petalCount; i++) {
    float x = t.getX() + cos(radians(currentAngle)) * petalSize;
    float y = t.getY() + sin(radians(currentAngle)) * petalSize;
    ellipse(x, y, petalSize, petalSize * 3); // Adjust the size and shape of the petals
    currentAngle += angleIncrement;
  }
  
  stroke(0);
  noFill();
  }
  
  /**
  Method to create the sunflower designs
  **/
  void drawSunflower(float x, float y) {
    // Draw the center of the sunflower
    fill(255, 200, 0); // Yellow color
    ellipse(x, y, 20, 20); // Adjust the size of the center

    // Draw the seeds
    fill(0); // Black color
    for (int i = 0; i < 360; i += 30) {
        float seedX = x + cos(radians(i)) * 15;
        float seedY = y + sin(radians(i)) * 15;
        ellipse(seedX, seedY, 5, 5); // Adjust the size of the seeds
    }

    // Draw the petals
    fill(255, 255, 0); // Orange color
    for (int i = 0; i < 360; i += 45) {
        float petalX = x + cos(radians(i)) * 35;
        float petalY = y + sin(radians(i)) * 35;
        ellipse(petalX, petalY, 30, 20); // Adjust the size and shape of the petals
    }
}

}
